from tkinter import *
from ScreenManager import ScreenManager
from home.ScreenHome import ScreenHome
from snake.ScreenSnake import ScreenSnake
from morpion.ScreenMorpion import ScreenMorpion
from tapetaupe.ScreenTapetaupe import ScreenTapetaupe
from juste.ScreenJuste import ScreenJuste
from pong.ScreenPong import ScreenPong

class Application:
	
	def __init__(self):
		self.fen = Tk()
		self.fen.geometry("1200x800")
		self.fen['bg'] = "white"

		self.sm = ScreenManager(self)
		screenHome = ScreenHome(self)
		screenSnake = ScreenSnake(self)
		screenMorpion = ScreenMorpion(self)
		screenTapetaupe = ScreenTapetaupe(self)
		screenJuste = ScreenJuste(self)
		screenPong = ScreenPong(self)
		
		self.sm.append("home", screenHome)
		self.sm.append("snake", screenSnake)
		self.sm.append("morpion", screenMorpion)
		self.sm.append("tapetaupe", screenTapetaupe)
		self.sm.append("juste", screenJuste)
		self.sm.append("pong", screenPong)
		self.sm.display("home")

		self.fen.mainloop()
	
	def quit(self):
		self.fen.destroy()