import threading 


class Timer:
    
    def __init__(self,onChangeTimerCallback, onFinishTimerCallback, maxTime, tickTime):

        self.currentTime = 0
        self.tickTime = tickTime
        self.maxTime = maxTime
        self.onChange = onChangeTimerCallback
        self.onFinish = onFinishTimerCallback
        self.timer = None

    
    def start(self):
        self.currentTime = 0
        print("start "+ str(self.timer))
        if self.timer != None :
            self.timer.cancel()
        self.timer = threading.Timer(self.tickTime, self.tick)
        self.timer.start()

    
    def stop(self):
        if self.timer != None :
            self.timer.cancel()
            self.timer = None

            
    def tick (self):
        self.currentTime += self.tickTime
        self.timer.cancel()
        if self.currentTime >= self.maxTime :
            self.stop()
            if self.onFinish != None :
                self.onFinish(self)
            if self.onChange != None :
                self.onChange(self)
        else :
            if self.onChange != None :
                self.onChange(self)
            self.timer = threading.Timer(self.tickTime, self.tick)
            self.timer.start()