from tkinter import *
from PIL import ImageTk as itk
from PIL import Image

class Case:
	
	def __init__(self, game, x, y, onClickCallback):
		self.game = game
		self.width=int(game.width/game.nbcase)
		self.height=int(game.height/game.nbcase)
		self.x=x
		self.y=y
		img1 = Image.open("morpion/assets/croix.png")
		img1 = img1.resize((self.width,self.height), Image.ANTIALIAS)
		self.img1  =  itk.PhotoImage(img1)

		img2 = Image.open("morpion/assets/rond.png")
		img2 = img2.resize((self.width,self.height), Image.ANTIALIAS)
		self.img2  =  itk.PhotoImage(img2)

		self.onClickCallback = onClickCallback
		# state -> 0 : pas coché, 1 : coché par joueur A, 2 : cochée par joueur B
		self.state = 0
		self.canvas = Canvas(self.game.app.fen, width=self.width, height=self.height, bg='white')
		self.canvas.place(x=50+(self.x * self.width), y=50+(self.y*self.height))
		self.canvas.bind("<Button-1>", self.onClick)
	
	
	def onClick(self, event):
	
		if self.state == 0 :		
			print("click case")
			if self.game.counter % 2 == 0 :
				self.state = 1
			else :
				self.state = 2
				
			print(self.x)
			print(self.y)
			
			self.render()
			self.game.counter += 1
			
			if self.onClickCallback != None :
				self.onClickCallback(self)
			
	def render(self):
		self.canvas.delete("all")
		if self.state == 1 :
			#self.canvas.create_text(self.width/2,self.height/2,text="X")
			self.canvas.create_image(0, 0, anchor="nw", image=self.img1)
		elif self.state == 2 :
			#self.canvas.create_text(self.width/2,self.height/2,text="O")
			self.canvas.create_image(0, 0, anchor="nw", image=self.img2)
	