from tkinter import *
from morpion.Case import Case
from tkinter.messagebox import *

class MorpionGame:
	
	def __init__(self, app):
		self.app = app
		self.width=700
		self.height=700
		self.nbcase = 3
		self.canvas = Canvas(self.app.fen, width=self.width, height=self.height, bg='white')
		self.canvas.place(x=50, y=50)
		self.counter = 0
		self.cases = []
		
		# create cases
		self.createCases()
		
	def restart(self):
		self.cases = []
		self.createCases()
		self.counter = 0
		
	def createCases(self):
		for x in range(self.nbcase):	
			for y in range(self.nbcase):
				self.cases.append(Case(self, x, y , self.isWin))
				
				
	def isWin(self, case) :
		print("is win ?")
		
		for c in self.cases :
			print(c.state)
		
		
		
		# verify if player 1 win ?
		if self.isWinByPlayer(1) :
			self.popup("PLAYER 1 WIN")
		elif self.isWinByPlayer(2) :
			self.popup("PLAYER 2 WIN")
		elif self.isMatchDraw() :
			self.popup("DRAW")
	
	
	def popup(self,msg):
		showinfo("result",message=msg,default="ok")
		self.restart()
	
	
	def isMatchDraw(self) :
		for c in self.cases :
			if c.state == 0 :
				return False
	
		return True
		
	def isWinByPlayer(self, state) :
		
		if self.cases[0].state == state and self.cases[1].state == state and self.cases[2].state == state :
			return True
		if self.cases[3].state == state and self.cases[4].state == state and self.cases[5].state == state :
			return True
		if self.cases[6].state == state and self.cases[7].state == state and self.cases[8].state == state :
			return True
		if self.cases[0].state == state and self.cases[3].state == state and self.cases[6].state == state :
			return True
		if self.cases[1].state == state and self.cases[4].state == state and self.cases[7].state == state :
			return True
		if self.cases[2].state == state and self.cases[5].state == state and self.cases[8].state == state :
			return True
		if self.cases[0].state == state and self.cases[4].state == state and self.cases[8].state == state :
			return True
		if self.cases[2].state == state and self.cases[4].state == state and self.cases[6].state == state :
			return True
		else :
			return False
		