from tkinter import *
from random import *
from PIL import ImageTk as itk
from PIL import Image


class Case:
	
	def __init__(self, game, x, y, onClickCallback):
		self.game = game
		self.width=int(game.width/game.nbcase)
		self.height=int(game.height/game.nbcase)
		self.x=x
		self.y=y
		self.valeurtaupe = 0
		self.temps = 0
		self.onClickCallback = onClickCallback
		# state -> quand 1 = taupe sinon = 0
		self.state = 0
		self.taupe = 0
		self.img = None
	
		
		img1 = Image.open("tapetaupe/assets/normal.png")
		img1 = img1.resize((self.width,self.height), Image.ANTIALIAS)
		self.img1  =  itk.PhotoImage(img1)
		
		img2 = Image.open("tapetaupe/assets/tempsbonus.jpg")
		img2 = img2.resize((self.width,self.height), Image.ANTIALIAS)
		self.img2  =  itk.PhotoImage(img2)
		
		img5 = Image.open("tapetaupe/assets/rottentaupe.png")
		img5 = img5.resize((self.width,self.height), Image.ANTIALIAS)
		self.img5  =  itk.PhotoImage(img5)
		
		img4 = Image.open("tapetaupe/assets/goldentaupe.png")
		img4 = img4.resize((self.width,self.height), Image.ANTIALIAS)
		self.img4  =  itk.PhotoImage(img4)
		
		img3 = Image.open("tapetaupe/assets/timermalus.jpg")
		img3 = img3.resize((self.width,self.height), Image.ANTIALIAS)
		self.img3  =  itk.PhotoImage(img3)
		
		img6 = Image.open("tapetaupe/assets/bretontaupe.jpg")
		img6 = img6.resize((self.width,self.height), Image.ANTIALIAS)
		self.img6  =  itk.PhotoImage(img6)
		
		img7 = Image.open("tapetaupe/assets/bonetaupe.jpg")
		img7 = img7.resize((self.width,self.height), Image.ANTIALIAS)
		self.img7  =  itk.PhotoImage(img7)
		
		img8 = Image.open("tapetaupe/assets/moutaupe.jpg")
		img8 = img8.resize((self.width,self.height), Image.ANTIALIAS)
		self.img8  =  itk.PhotoImage(img8)
		
		self.canvas = Canvas(self.game.app.fen, width=self.width, height=self.height, highlightbackground = "white", bg = "white" ) 
		self.canvas.place(x=50+(self.x * self.width), y=50+(self.y*self.height))
		self.canvas.bind("<Button-1>", self.onClick)
		self.setTaupes()
		self.render()
		
	def onClick (self,event):
		if self.state == 1:
			self.setState(0)
			if self.onClickCallback != None:
				self.onClickCallback(self)
			
	def setState (self, state):
		self.state = state
		self.render()
			
			
	def setTaupes (self):
		nbr=randint(0,100)
		if nbr < 60:
			self.normal()
		elif nbr < 68:
			self.taupetempsbonus()
		elif nbr < 73:
			self.taupetempsmalus()
		elif nbr < 83:
			self.goldentaupe()
		elif nbr < 90:
			self.rottentaupe()
		elif nbr < 95:
			self.moutaupe()	
		elif nbr < 100:
			self.bonetaupe()	
		else:
			self.bretontaupe()	
					
					
					
	def normal (self):
		self.taupe = 1
		self.valeurtaupe = 100
		self.img = self.img1
		
	def taupetempsbonus (self):
		self.taupe = 2
		self.temps = 5
		self.valeurtaupe = 100
		self.img = self.img2
		
	def taupetempsmalus (self):
		self.taupe = 3
		self.temps = -5
		self.valeurtaupe = 0
		self.img = self.img3
		
	def goldentaupe (self):
		self.taupe = 4
		self.valeurtaupe = 500
		self.img = self.img4
		
	def rottentaupe (self):
		self.taupe = 5
		self.valeurtaupe = -500
		self.img = self.img5
		
	def bretontaupe (self):
		self.taupe = 6
		self.valeurtaupe = 5000
		self.img = self.img6
		
	def bonetaupe (self):
		self.taupe = 7
		self.valeurtaupe = 2500
		self.img = self.img7
		
	def moutaupe (self):
		self.taupe = 8
		self.valeurtaupe = None
		#fin de partie
		self.img = self.img8
			
	def render(self):  
		self.canvas.delete("all")
		if self.state == 1:
			self.canvas.create_image(0, 0, anchor="nw", image = self.img)
			