from tkinter import*
from tapetaupe.TapetaupeGame import TapetaupeGame
from tkinter.messagebox import *

class ScreenTapetaupe:
    
    def __init__(self, app):
        self.app = app
        self.game = None
        self.labelTimer = None
        self.labelPoint = None
        
    def back(self):
        self.game.stop()
        self.app.sm.display("home")
    
    def restart(self):
        self.game.restart()
    
    def gameover(self):
        if self.game.points == 0 :
            showinfo("GAME OVER",message="points: 0", default="ok")
        else :
            showinfo("GAME OVER",message=("points: " , self.game.points), default="ok")
    
    def onChangeTimerCallback(self, timer):

        self.labelTimer.config(text = 120-timer.currentTime)
        if timer.currentTime == timer.maxTime :
            self.gameover()
            
    def onGameOverCallback(self):
        self.gameover()
    
    def onPointChangeCallback (self, points):
        self.labelPoint.config(text = points)
    
    def display(self):
        fen = self.app.fen
        fen['bg'] = "white"
        Button(fen, text ='Retour', command = self.back,font=("gothic", 30), background="pink").place(bordermode=INSIDE, height=100, width=200, x=875, y=600)
        Button(fen, text ='Start', command = self.restart,font=("gothic", 30), background="pink").place(bordermode=INSIDE, height=100, width=200, x=875, y=450)
        Label(fen, text ='Tape Taupe',font=("gothic", 30), fg="orange", background="white").place(bordermode=INSIDE ,height=100, width=400, x=775, y=300)
        self.labelTimer = Label(fen, text ='',font=("gothic", 30), fg="pink", background="white")
        self.labelTimer.place(bordermode=INSIDE ,height=100, width=400, x=775, y=175)
        self.labelPoint = Label(fen, text ='',font=("gothic", 30), fg="pink", background="white")
        self.labelPoint.place(bordermode=INSIDE ,height=100, width=400, x=775, y=75)
        self.game = TapetaupeGame(self.app, self.onChangeTimerCallback )
        self.game.onPoint = self.onPointChangeCallback
        self.game.onGameOver = self.onGameOverCallback