from tkinter import *
from tapetaupe.Case import Case
from tkinter.messagebox import *
from random import *
from Timer import Timer
#from tapetaupe.AssetManager import AssetManager



class TapetaupeGame:
    
    def __init__(self,app, onChangeTimerCallback):
        self.app = app
        self.width=700
        self.height=700        
        self.fond = Canvas(self.app.fen, width=self.width+4, height=self.height+4, highlightbackground = "black", bg = "white" )
        self.fond.place(x=48, y=48) 
        self.nbcase = 10
        self.points = 0
        self.cases = []
        self.onGameOver = None
        self.onPoint = None
        self.tickglobal = 1
        #self.canvas = Canvas(self.app.fen, width=self.width, height=self.height, bg='white')
        #self.canvas.place(x=50, y=50)
        self.timer = Timer(onChangeTimerCallback, self.onFinishTimerCallback, 120, self.tickglobal)
        self.timerCaseMaxTimer = 3
        self.timerCase = Timer(None, self.onFinishTimerCaseCallback,self.timerCaseMaxTimer, 0.2)
        #creation de cases 
        #self.createCases()
 
    
    def createCases (self):
        for x in range(self.nbcase):	
            for y in range(self.nbcase):
                self.cases.append(Case(self, x, y,self.onClickCallback))


    def onFinishTimerCallback(self, timer):
        self.gameOver()

    
    def restart(self):
        self.cases = []
        self.createCases()
        self.showMoles()
        self.points = 0
        self.stop()
        self.timer.start()
        self.timerCase.start()
 
    
    def showMoles (self):
        nbrtaupes = randint(1,3)
        for i in range(nbrtaupes):
            indexcase = randint(0,(self.nbcase**2)-1)
            self.cases[indexcase].setState(1)
 
    
    def hideMoles(self):
        for case in self.cases :
            case.setState(0)
        # recalcul du temps max du timer case
        self.timerCase.maxTime = self.timerCaseMaxTimer - (self.timer.currentTime/50) 
        print(self.timerCase.maxTime) 
   
    
    def onFinishTimerCaseCallback(self, timer):
        self.hideMoles()
        self.showMoles()
        self.timerCase.start()

        
    def stop(self) :
        self.timer.stop()
        self.timerCase.stop()

        
    def gameOver(self) :
        self.stop()
        self.hideMoles()
        if self.onGameOver != None :
            self.onGameOver() 
 
        
    def onClickCallback (self,case):
        if case.taupe == 8 :
            self.points = 0
            if self.onPoint != None :
                self.onPoint(self.points)
            self.gameOver()
        elif case.taupe==2 or case.taupe == 3:
            self.timer.currentTime -= case.temps
            self.points += case.valeurtaupe
            if self.onPoint != None :
                self.onPoint(self.points)
        else :
            self.points += case.valeurtaupe
            if self.onPoint != None :
                self.onPoint(self.points)
            print(self.points)